#include "stdafx.h"
 
#include "cpss_dialog.h"
#include <stdio.h>
#include "TireCfg.h"
#include "threshdlg.h"
 

#define  HEIGHT_BUTTON_WIDTH 80


#define PAGES 2
 
 typedef struct {
	UINT nID; //tire identify
	char  pstr[32]; // used when nID==-1
	POINT pt;	 
	//COLORREF color;
	CMyBitmap placehold[2];
}  DISPLAY_CELL;

#define Y_FIST 100
#define Y_MID1 170-1
#define Y_MID2 240-2
#define Y_LAST 310-3
//#define NULL_MYBITMAP {NULL,NULL}
static DISPLAY_CELL  display_cell [ ]={
	{0x0B,{0},{110,Y_FIST} },{0x03,{0},{110,Y_LAST} },	 
	{0x5B,{0},{312,Y_FIST} },{0x59,{0},{312,Y_MID1} },{0x55,{0},{312,Y_MID2} },{0x53,{0},{312,Y_LAST} }
};

 
static DISPLAY_CELL  display_cell2 [ ]={
	{0xBB,{0},{230,Y_FIST}},{0xB9,{0},{230,Y_MID1}},{0xB5,{0},{230,Y_MID2}},{0xB3,{0},{230,Y_LAST}},
	{0xCB,{0},{380,Y_FIST}},{0xC9,{0},{380,Y_MID1}},{0xC5,{0},{380,Y_MID2}},{0xC3,{0},{380,Y_LAST}},
	{0xDB,{0},{530,Y_FIST}},{0xD9,{0},{530,Y_MID1}},{0xD5,{0},{530,Y_MID2}},{0xD3,{0},{530,Y_LAST}},
};

  
 #define m_btnlist m_Btns
 #define m_btAct (&m_Btns[1])

#define m_btn2Func m_Btns[3]
static const BUTTON_ITEMEX Button_LR[] = {{ 452,30,	228,72,IDD_BUTTONS_RIGHT    ,IDD_BUTTONS_RIGHT      ,0}};
#define RL_BTN_FUNC(l,r)  	((COD2ButtonImpl*)&m_btn2Func)->ChangeFunc(l,r,m_nIDBACK, \
	(l!=r)?IDBI_LEFTRIGHT_LR:(l==IDD_BUTTONS_RIGHT?IDBI_LEFTRIGHT_RIGHT:IDBI_LEFTRIGHT_LEFT ),	 \
	(l!=r)?IDBI_LEFTRIGHT_LR_DN:(l==IDD_BUTTONS_RIGHT?IDBI_LEFTRIGHT_RIGHT_DN:IDBI_LEFTRIGHT_LEFT_DN ),	 \
								  Button_LR[0].rt.left,Button_LR[0].rt.top)

//static DWORD WINAPI CommandTask(void*para );


 
//#define TIMEOUT_COMMAND 10000
//static HANDLE g_hCommandThread=NULL;
 
static const BUTTON_ITEM Button_EngInfo[] ={ { Btn_CancelX, Btn_CancelY, Btn_CancelWidth,Btn_CancelHeight,ID_CANCEL,	IDBI_CANCEL,IDBI_CANCEL_DN}};
 

static const BUTTON_ITEMEX Button1_EngInfo[] = 
{
	//{ 416, 121,	44,	    44,ID_BACKSPACE ,IDB_BACKSPACE    ,IDB_BACKSPACE_DN },  //For Name
	//{ 416, 165,	44,	    44,ID_UPICON    ,IDB_UPICON       ,IDB_UPICON_DN},
	//{ 560 , 371,	HEIGHT_BUTTON_WIDTH , 43,ID_BUTTON_RESET,IDB_BDCOMP_BUTTON_RESET , IDB_BDCOMP_BUTTON_RESET_DN,   0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL},
	{ 480, Btn_CancelY,	250,42,IDS_WERTE    ,IDBI_BUTTON_121x43  ,IDBI_BUTTON_121x43_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_CFG},
	 
};
static const BUTTON_ITEMEX Button2_Info[] = 
{
	{ 40, Btn_CancelY+1,	250,42,IDS_Reifen_Aktuelle    ,IDB_Reifen_Aktuelle_BTN  ,IDB_Reifen_Aktuelle_BTN_DN,0,0,0,0,TitleFontWide,TitleFontHeight,FW_NORMAL,IDS_Reifen_Aktuelle}

};

//static HANDLE ghExitEvent=NULL;

LRESULT TireCfg::OnInitDialog(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 	CString str;
	for(int i=0; i<sizeof(Button_EngInfo)/sizeof(BUTTON_ITEM) ; i++)
	{
		CREATE_BTN_TRANS2(m_btnlist[i], m_nIDBACK, Button_EngInfo[i]);
	}

	RECT rect;
	rect = Button1_EngInfo[0].rt;
	
	 
	for(int i=0; i<sizeof(Button1_EngInfo)/sizeof(BUTTON_ITEMEX) ; i++)
	{
		BOOL bEnable = true;
		
	
		str.LoadString(Button1_EngInfo[i].uId );
		CREATE_BTN_TRANS(m_btAct[i], m_nIDBACK,str,Button1_EngInfo[i]);
		
	}
 	str.LoadString(Button2_Info[0].uId );
	CREATE_BTN_TRANS(m_btAct[1], m_nIDBACK,str,Button2_Info[0]);

	m_btn2Func.CreateWndTrans(m_hWnd,m_nIDBACK,Button_LR[0].rt,IDD_BUTTONS_RIGHT,
								  IDBI_LEFTRIGHT_RIGHT,
								  IDBI_LEFTRIGHT_RIGHT_DN);	


		 


	//DWORD dwID;
	//ghExitEvent = CreateEvent(NULL,FALSE,FALSE,NULL);
	//g_hCommandThread = CreateThread(NULL,0 , CommandTask ,(void*)m_hWnd,0, &dwID);


	//OnButton2(0,0,0, bHandled);
	
//	SetTimer(1,5000,NULL);
	VButtonWnd::OnInitDialog(uMsg, wParam, lParam, bHandled) ;
    return 0;  
}

#define CELL_H 62
#define CELL_W 140
void TireCfg::OnPaintExt(HDC hDC,CRect& rcPaint)
{
	DrawDC Draw(hDC);
	CCanvas canvas(hDC);
	Draw.SetDrawBkMode(TRANSPARENT);
	CRect rect;
	HFONT hOldFont = Draw.SetFont(m_hBigFont);
	CString str;
	Draw.SetDrawTextColor(RGB(255,255,255));
	str.LoadString(IDS_Konfigurationsmodus);
	Draw.DrawStringAt((LPTSTR)(LPCTSTR)str,120 ,50);


DISPLAY_CELL * pCell=0;
	int count;
	if(m_nIndex==0) 
	{
		pCell = display_cell;
		count = sizeof(display_cell)/sizeof(DISPLAY_CELL);
	}else
	{
		pCell = display_cell2;
		count = sizeof(display_cell2)/sizeof(DISPLAY_CELL);
	}
	int i,j;
	UINT bold = 32;
	for(i=0;i<count;i++)
	{
		rect.left = pCell[i].pt.x;rect.top = pCell[i].pt.y;
		rect.right = rect.left+ CELL_W;rect.bottom = rect.top+ CELL_H;

		//if(pCell[i].color==0) pCell[i].color = TUHUANG_CLR ;
		//if( tire_selected(pCell[i].nID)!=-1) Draw.DrawNewRect2(&rect,FALSE,TRUE,0);
		//else Draw.DrawNewRect2(&rect,TRUE,TRUE,0);
		int t=0;
		if( tire_selected(pCell[i].nID)!=-1) t=1;	else t = 0;
		draw_placeholder(pCell[i].placehold[t],(t?IDB_PLACE_141_YELLOW:IDB_PLACE_141));
		/*if(pCell[i].placehold[t].m_hBitmap==NULL)
		{
			pCell[i].placehold[t].LoadBitmap(t?IDB_PLACE_141_YELLOW:IDB_PLACE_141,m_nIDBACK,rect.left,rect.top);
		}
		canvas.BitBlt(pCell[i].placehold[t],rect.left,rect.top,TRUE);*/
		if(Y_MID1== pCell[i].pt.y || Y_MID2== pCell[i].pt.y ) Draw.SetDrawTextColor(RGB(0,0,0));
		else Draw.SetDrawTextColor(RGB(255,255,255));
		TIRE_CFG* cfg = find_cfg(pCell[i].nID);
		if(cfg)
		{
			rect.bottom-= rect.Height()/2;rect.top+=2;
			char sz[16];
			sprintf(sz,"%.1f ",cfg->pressure[1]);
			Draw.DrawStringRect(convert_val(sz,PRESS_UNIT),&rect,DT_CENTER|DT_VCENTER);
			rect.OffsetRect(0,rect.Height()-2);
			sprintf(sz,"%.0f ",cfg->temp[1]);
			Draw.DrawStringRect(convert_val(sz,TEMP_UNIT),&rect,DT_CENTER|DT_VCENTER);
		}
	 
	}
 
	Draw.SetFont(hOldFont);
	 
}
 


 void alertMsg(UINT ids);
LRESULT TireCfg::OnCfg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	if(m_nSelectTire.GetSize()<=0)
	{
		alertMsg(IDS_REIFEN_WARN);
	}else{
		ThreshDlg dlg(m_nSelectTire);
		dlg.DoModal();
	}
  return 0;
}


LRESULT TireCfg::OnCancelMsg(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	//SetEvent(ghExitEvent);
	//if(	g_hCommandThread ) WaitForSingleObject(g_hCommandThread,TIMEOUT_COMMAND); g_hCommandThread=0;
	__restore_pre_window_handle__(m_hWnd);
	
	//CloseHandle(ghExitEvent);
	EndDialog(1);
	//PostQuitMessage(0);
	
	return 0;
}



LRESULT TireCfg::OnTimer(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& /*bHandled*/)
{
	BOOL bHandled;
//	OnButton2(0,0,0, bHandled);
	return 0;
}


LRESULT TireCfg::OnUserIndicate(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
 
 

	return 0;
} 

 void TireCfg::UpdatePage(int page)
{
	if(page==0)
		RL_BTN_FUNC(IDD_BUTTONS_RIGHT,IDD_BUTTONS_RIGHT);
	else if( page==PAGES-1)
		RL_BTN_FUNC(IDD_BUTTONS_LEFT,IDD_BUTTONS_LEFT);
	else RL_BTN_FUNC(IDD_BUTTONS_LEFT, IDD_BUTTONS_RIGHT);
 
	int id = IDB_Reifen_BK2;
	if(page==0){ id = IDB_Reifen_BK1; }
	else id = IDB_Reifen_BK2;
	m_DrawList->ReplaceBK(id );
	m_nIDBACK = id;
	Invalidate();
	UpdateWindow();
 	
}
 
LRESULT TireCfg::OnLeftRight(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& bHandled)
{
	if(wID == IDD_BUTTONS_RIGHT) {
		if(m_nIndex<1) m_nIndex++;
	}
	else if(wID == IDD_BUTTONS_LEFT) 
	{	 
		if(m_nIndex>0) m_nIndex--;
	}
	bHandled = 1;
	UpdatePage(m_nIndex);
 
	return 1;
}

void*  TireCfg::check_tire(CPoint pt)
 {
	 
DISPLAY_CELL * pCell=0;
	int count;
	if(m_nIndex==0) 
	{
		pCell = display_cell;
		count = sizeof(display_cell)/sizeof(DISPLAY_CELL);
	}else
	{
		pCell = display_cell2;
		count = sizeof(display_cell2)/sizeof(DISPLAY_CELL);
	}
	int i,j;
	CRect rect;
	for(i=0;i<count;i++)
	{
		rect.left = pCell[i].pt.x;rect.top = pCell[i].pt.y;
		rect.right = rect.left+ CELL_W;rect.bottom = rect.top+ CELL_H;
		if(rect.PtInRect(pt))
		{
			select_tire(pCell[i].nID); //m_nSelectTire = pCell[i].nID;
			return &pCell[i];
		}
	}
	return NULL;
 }

int  TireCfg::tire_selected(int id)
{
	int c = m_nSelectTire.GetSize();
	int i;
	for(i=0;i<c;i++)
	{
		if(m_nSelectTire[i]==id)
			return i;
	}
	return -1;
}
void  TireCfg::select_tire(int id)
{
	int n = tire_selected(id) ;
	if(n==-1)
	{
		m_nSelectTire.Add(id);
	}else m_nSelectTire.RemoveAt(n);
}
 LRESULT  TireCfg::OnLButtonDown(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
 {
	 LRESULT l = VButtonWnd::OnLButtonDown( uMsg ,   wParam,   lParam, bHandled);
	 if(l==0)
	 {
		CPoint pt( LOWORD(lParam), HIWORD(lParam));
		DISPLAY_CELL * pCell = (DISPLAY_CELL *) check_tire(pt);
		if(pCell)
		{
			RECT rect; 
			rect.left = pCell->pt.x;rect.top = pCell->pt.y;
			rect.right = rect.left+ CELL_W;rect.bottom = rect.top+ CELL_H;
			::InvalidateRect(m_hWnd,NULL,0);
		}
		
	 }
	 return l;
 }
 LRESULT  TireCfg::OnLButtonUp(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
 {
	  LRESULT l = VButtonWnd::OnLButtonUp( uMsg ,   wParam,   lParam, bHandled);
	 if(l==0)
	 {
	 }
	 return l;
 }

 LRESULT TireCfg::OnAktuelle(WORD /*wNotifyCode*/, WORD wID, HWND hWndCtl, BOOL& /*bHandled*/)
{
	
int DoAktuelle( );
	DoAktuelle( );
	Invalidate();UpdateWindow();
	return 0;
}

